<!-------------------------------------------------------------------------------------------------
  - #%L                                                                                           -
  - chvote-vrum                                                                                   -
  - %%                                                                                            -
  - Copyright (C) 2016 - 2018 République et Canton de Genève                                      -
  - %%                                                                                            -
  - This program is free software: you can redistribute it and/or modify                          -
  - it under the terms of the GNU Affero General Public License as published by                   -
  - the Free Software Foundation, either version 3 of the License, or                             -
  - (at your option) any later version.                                                           -
  -                                                                                               -
  - This program is distributed in the hope that it will be useful,                               -
  - but WITHOUT ANY WARRANTY; without even the implied warranty of                                -
  - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                                  -
  - GNU General Public License for more details.                                                  -
  -                                                                                               -
  - You should have received a copy of the GNU Affero General Public License                      -
  - along with this program. If not, see <http://www.gnu.org/licenses/>.                          -
  - #L%                                                                                           -
  ------------------------------------------------------------------------------------------------->

<div class="chvote-content">
  <mat-card class="card-processing-section">
    <mat-card-header>
      <mat-card-title>{{ 'voting-cards.card-processing.title' | translate }}</mat-card-title>
      <mat-card-subtitle>{{ 'voting-cards.card-processing.description' | translate }}</mat-card-subtitle>
    </mat-card-header>

    <mat-card-content fxLayout="column">
      <div class="title-group">
        <div class="voting-channels"
             *vrumRoles="[
             'ROLE_SELECT_MAIL_CHANNEL',
             'ROLE_SELECT_POLLING_STATION_CHANNEL',
             'ROLE_SELECT_OTHER_CHANNEL']">
          <p>{{ 'voting-cards.card-processing.voting-channels' | translate }}</p>
        </div>
        <div class="blocking-channel" *vrumRoles="['ROLE_SELECT_BLOCKING_CHANNEL']">
          <p>{{ 'voting-cards.card-processing.blocking-channel' | translate }}</p>
        </div>
      </div>

      <div class="button-group">
        <div class="voting-channels">
          <mat-button-toggle-group>
            <ng-container *ngFor="let votingChannel of votingChannels">
              <mat-button-toggle *vrumRoles="['ROLE_SELECT_' + votingChannel + '_CHANNEL']"
                                 [id]="'btn-channel-' + votingChannel"
                                 [ngClass]="{
                                   'pre-selected': !selectedVotingChannel && votingChannel === defaultVotingChannel
                                 }"
                                 [checked]="votingChannel === selectedVotingChannel"
                                 [value]="votingChannel"
                                 (change)="onChannelSelected(votingChannel)">
                {{ 'voting-cards.voting-channels.' + votingChannel | translate }}

              </mat-button-toggle>
            </ng-container>
          </mat-button-toggle-group>
        </div>
        <div class="blocking-channel" *vrumRoles="['ROLE_SELECT_BLOCKING_CHANNEL']">
          <mat-button-toggle #blocking
                             [id]="'btn-channel-' + blockingChannel"
                             [ngClass]="{
                               'pre-selected': !selectedVotingChannel && blockingChannel === defaultVotingChannel
                             }"
                             [checked]="blockingChannel === selectedVotingChannel"
                             [value]="blockingChannel"
                             (change)="onChannelSelected(blockingChannel)">
            {{ 'voting-cards.voting-channels.' + blockingChannel | translate }}
          </mat-button-toggle>
        </div>
      </div>

      <div class="card-search-section" *ngIf="selectedVotingChannel">
        <form (submit)="onSubmit()"
              class="card-search-form"
              fxLayout="row" fxLayout.lt-md="column" fxLayoutWrap fxLayoutGap="2.5%" fxLayoutAlign="center center">
          <mat-form-field fxFlex="25%">
            <input matInput id="card-identifier"
                   autocomplete="off"
                   [placeholder]="'voting-cards.card-processing.search-field-placeholder' | translate"
                   [formControl]="formControl">
            <mat-error *ngIf="formControl.invalid && formControl.hasError('required')">
              {{ 'voting-cards.card-processing.error.empty-field' | translate }}
            </mat-error>
          </mat-form-field>
          <button mat-icon-button type="submit">
            <mat-icon [class.done]="searchIcon !== 'search'">{{ searchIcon }}</mat-icon>
          </button>
        </form>
      </div>

      <div class="search-results voting-card-section" *ngIf="votingCard"
           fxLayout="column" fxLayoutWrap fxLayoutGap="2.5%" fxLayoutAlign="center">
        <div class="birth-date">
          {{ formatBirthDate(votingCard) }}
        </div>

        <div class="status"
             [class.success]="getOnSearchVotingCardStatusClass() === 'success'"
             [class.error]="getOnSearchVotingCardStatusClass() === 'error'"
             [class.not-found]="getOnSearchVotingCardStatusClass() === 'not-found'">
          {{ votingCardStatusMessage }}
        </div>

        <div fxLayout="row" fxLayoutWrap fxLayoutAlign="center">
          <div class="domain-of-influence" fxFlex="5%">
            <ul>
              <li *ngFor="let domainOfInfluence of votingCard.domainOfInfluences">
                {{ domainOfInfluence.businessId }}
              </li>
            </ul>
          </div>
          <div class="counting-circles" fxFlex="5%">
            <ul>
              <li>{{ votingCard.countingCircle.name }}</li>
            </ul>
          </div>
        </div>
      </div>

      <div class="search-results voting-card-section" *ngIf="responseStatus === 404"
           fxLayout="column" fxLayoutWrap fxLayoutGap="2.5%" fxLayoutAlign="center">
        <div class="status not-found">
          {{ 'voting-cards.card-processing.search-result.status.' + responseStatus | translate }}
        </div>
      </div>

    </mat-card-content>
  </mat-card>
</div>
